#include <iostream>

#include "penguin_heuristic.hpp"
#include "movement_freedom_heuristic.hpp"
#include "penguin.hpp"

#define MAX_NB_MOVES	60

using namespace std;

namespace mcts
{
  float movement_freedom_heuristic::get_value(const game::penguin& game, uint8_t move) const
  {    
	std::shared_ptr<game::penguin> played = game::copy(game);

	//TEST SOLUTION 1
	
    	played->play(move);
	game::penguin_state state = played->get_state();

	uint32_t* penguins = state.peng_blue;
	if(!state.current_player_red) {
		penguins = state.peng_red;
	}
	uint32_t nb_moves = 0;
	for(int i=0; i< 4; i++) {
		nb_moves += PENGUIN_TOT_MOVES(penguins[i]);
	}

	float res = 2.0f*(float)nb_moves / (float)MAX_NB_MOVES - 1.0f;

	return res;
	


	//TEST SOLUTION 2
	/*
    	played->play(move);
	uint32_t nb_moves = played->number_of_moves();

	float res = 2.0f*(float)nb_moves / (float)MAX_NB_MOVES - 1.0f;
	return res;
	*/

	//TEST SOLUTION 3
	/*
    	played->play(move);
	game::penguin_state state = played->get_state();

	uint32_t nb_moves = state.nb_moves_blue;
	if(!state.current_player_red) {
		nb_moves = state.nb_moves_red;
	}

	float res = 2.0f*(float)nb_moves / (float)MAX_NB_MOVES - 1.0f;

	return res;
	*/
  }

  int movement_freedom_heuristic::get_count(const game::penguin& game, uint8_t move) const
  {
    return 100000000;
  }
}
